"""
    CircuitStyles

A module to define the styles of the circuit visualization.
To change the styles, please modify the variables in this module, e.g.
```julia
julia> using YaoPlots

julia> YaoPlots.CircuitStyles.unit[] = 40
40
```

### Style variables
#### Sizes
* `unit` is the number of pixels in a unit.
* `r` is the size of nodes.
* `lw` is the line width.

#### Texts
* `textsize` is the text size.
* `paramtextsize` is the text size for longer texts.
* `fontfamily` is the font family.

#### Colors
* `linecolor` is the line color.
* `gate_bgcolor` is the gate background color.
* `textcolor` is the text color.
"""
module CircuitStyles
    using Luxor
    const unit = Ref(60)    # number of pixels in a unit
    const barrier_for_chain = Ref(false)
    const r = Ref(0.2)
    const lw = Ref(1.0)
    const textsize = Ref(16.0)
    const paramtextsize = Ref(10.0)
    const fontfamily = Ref("JuliaMono")
    #const fontfamily = Ref("Dejavu Sans")
    const linecolor = Ref("#000000")
    const gate_bgcolor = Ref("transparent")
    const textcolor = Ref("#000000")

    abstract type Gadget end
    struct Box{FT} <: Gadget
        height::FT
        width::FT
    end
    struct Cross <: Gadget end
    struct Dot <: Gadget end
    struct NDot <: Gadget end
    struct OPlus <: Gadget end
    struct MeasureBox <: Gadget end
    struct Phase <: Gadget
        text::String
    end
    struct Text{FT} <: Gadget
        fontsize::FT
    end
    struct Line <: Gadget end
    get_width(::Cross) = 0.0
    get_width(::Phase) = r[]/2.5
    get_width(::Dot) = r[]/2.5
    get_width(::NDot) = r[]/2.5
    get_width(::OPlus) = r[]*1.4
    boxsize(b::Gadget) = (w = get_width(b); (w, w))
    function boxsize(b::Box)
        return b.width, b.height
    end
    function boxsize(::MeasureBox)
        return 2 * r[], 2 * r[]
    end

    function render(b::Box, loc)
        setcolor(gate_bgcolor[])
        Luxor.box(Point(loc)*unit[], b.width*unit[], b.height*unit[], :fill)
        setcolor(linecolor[])
        setline(lw[])
        Luxor.box(Point(loc)*unit[], b.width*unit[], b.height*unit[], :stroke)
    end

    function render(d::Dot, loc)
        setcolor(linecolor[])
        circle(Point(loc)*unit[], get_width(d)*unit[]/2, :fill)
    end
    function render(d::Phase, loc)
        x0 = Point(loc)*unit[]
        setcolor(linecolor[])
        circle(x0, get_width(d)*unit[]/2, :fill)
        setcolor(textcolor[])
        fontsize(textsize[])
        fontface(fontfamily[])
        text(d.text, x0+Point(8,8); valign=:middle, halign=:center)
    end
    function render(d::NDot, loc)
        setcolor(gate_bgcolor[])
        circle(Point(loc)*unit[], get_width(d)*unit[]/2, :fill)
        setcolor(linecolor[])
        setline(lw[])
        circle(Point(loc)*unit[], get_width(d)*unit[]/2, :stroke)
    end
    function render(::Cross, loc)
        setline(lw[])
        setcolor(linecolor[])
        line(Point(loc[1]-r[]/sqrt(2), loc[2]-r[]/sqrt(2))*unit[], Point(loc[1]+r[]/sqrt(2), loc[2]+r[]/sqrt(2))*unit[], :stroke)
        line(Point(loc[1]-r[]/sqrt(2), loc[2]+r[]/sqrt(2))*unit[], Point(loc[1]+r[]/sqrt(2), loc[2]-r[]/sqrt(2))*unit[], :stroke)
    end
    function render(d::OPlus, loc)
        w = get_width(d) / 2
        setcolor(gate_bgcolor[])
        circle(Point(loc)*unit[], w*unit[], :fill)
        setcolor(linecolor[])
        setline(lw[])
        x0 = Point(loc)*unit[]
        circle(x0, w*unit[], :stroke)
        line(x0+Point(-w*unit[], 0.0), x0+Point(w*unit[], 0.0*unit[]), :stroke)
        line(x0+Point(0.0, -w*unit[]), x0+Point(0.0*unit[], w*unit[]), :stroke)
    end
    function render(::MeasureBox, loc)
        x0 = Point(loc)*unit[]
        setcolor(gate_bgcolor[])
        box(x0, 2*r[]*unit[], 2*r[]*unit[], :fill)
        setcolor(linecolor[])
        setline(lw[])
        box(x0, 2*r[]*unit[], 2*r[]*unit[], :stroke)
        move(x0+Point(-0.8*r[], 0.5*r[])*unit[])
        curve(
            x0+Point(-0.8*r[], -0.6*r[])*unit[],
            x0+Point(0.8*r[], -0.6*r[])*unit[],
            x0+Point(0.8*r[], 0.5*r[])*unit[])
        strokepath()
        line(x0+Point(0.0, 0.5*r[])*unit[], x0+Point(0.7*r[], -0.4*r[])*unit[], :stroke)
    end

    function render(::Line, locs)
        setcolor(linecolor[])
        setline(lw[])
        line(Point(locs[1])*unit[], Point(locs[2])*unit[], :stroke)
    end
    function render(t::Text, loctxt)
        loc, txt, width, height = loctxt
        fontsize(t.fontsize)
        fontface(fontfamily[])
        #fontface("Dejavu Sans")
        setcolor(textcolor[])
        if contains(txt, '\n')
            for (i, txt) in enumerate(split(loctxt[2], "\n"))
                text(txt, Point(loc)*unit[]+i*Point(0, t.fontsize)-Point((width-0.1)*unit[]/2, height*unit[]/2); halign=:left, valign=:middle)
            end
        else
            text(txt, Point(loc)*unit[]; halign=:center, valign=:middle)
        end
    end

    Base.@kwdef struct GateStyles
        g = Box(2*r[], 2*r[])
        c = Dot()
        x = Cross()
        nc = NDot()
        not = OPlus()
        measure = MeasureBox()

        # other styles
        line = Line()
        text = Text(textsize[])
        smalltext = Text(paramtextsize[])
    end
end

struct CircuitGrid
    frontier::Vector{Int}
    w_depth::Float64
    w_line::Float64
    gatestyles::CircuitStyles.GateStyles
end

nline(c::CircuitGrid) = length(c.frontier)
depth(c::CircuitGrid) = frontier(c, 1, nline(c))
Base.getindex(c::CircuitGrid, i, j) = (c.w_depth*i, c.w_line*j)
Base.typed_vcat(c::CircuitGrid, ij1, ij2) = (c[ij1...], c[ij2...])

function CircuitGrid(nline::Int; w_depth=1.0, w_line=1.0, gatestyles=CircuitStyles.GateStyles())
    CircuitGrid(zeros(Int, nline), w_depth, w_line, gatestyles)
end

function frontier(c::CircuitGrid, args...)
    maximum(i->c.frontier[i], min(args..., nline(c)):max(args..., 1))
end

function _draw!(c::CircuitGrid, loc_brush_texts)
    isempty(loc_brush_texts) && return
    # a loc can be a integer, or a range
    loc_brush_texts = sort(loc_brush_texts, by=x->maximum(x[1]))
    locs = Iterators.flatten(getindex.(loc_brush_texts, 1)) |> collect

    # get the gate width and the circuit depth to draw
    boxwidths, boxheights = Float64[], Float64[]
    loc_brush_texts = map(loc_brush_texts) do (j, b, txt)
        if length(j) != 0
            wspace, _ = text_width_and_size(txt)
            hspace = (maximum(j)-minimum(j)) * c.w_line
            # make box larger
            b = b isa CircuitStyles.Box ? CircuitStyles.Box(b.height + hspace, b.width + wspace) : b
            boxwidth, boxheight = CircuitStyles.boxsize(b)
            push!(boxwidths, boxwidth)
            push!(boxheights, boxheight)
        end
        (j, b, txt)
    end
    max_width = maximum(boxwidths)
    ncolumn = max(1, ceil(Int, max_width/c.w_depth + 0.2))  # 0.1 is the minimum gap between two columns

    ipre = frontier(c, minimum(locs):maximum(locs)...)
    i = ipre + ncolumn/2
    local jpre
    for (k, ((j, b, txt), boxheight)) in enumerate(zip(loc_brush_texts, boxheights))
        length(j) == 0 && continue
        _, fontsize = text_width_and_size(txt)
        jmid = (minimum(j)+maximum(j))/2
        CircuitStyles.render(b, c[i, jmid])
        CircuitStyles.render(CircuitStyles.Text(fontsize), (c[i,jmid], txt, CircuitStyles.boxsize(b)...))
        # use line to connect blocks in the same gate
        if k!=1
            CircuitStyles.render(c.gatestyles.line, c[(i, jmid-boxheight/2/c.w_line); (i, jpre)])
        end
        jpre = jmid + boxheight/2/c.w_line
    end

    #jmin, jmax = min(locs..., nline(c)), max(locs..., 1)
    # connect horizontal lines
    for (width, (j, b, txt)) in zip(boxwidths, loc_brush_texts)
        for jj in j
            CircuitStyles.render(c.gatestyles.line, c[(c.frontier[jj], jj); (i-width/2/c.w_depth, jj)])
            CircuitStyles.render(c.gatestyles.line, c[(i+width/2/c.w_depth, jj); (ipre+ncolumn, jj)])
            c.frontier[jj] = ipre + ncolumn
        end
    end
    for j in setdiff(minimum(locs):maximum(locs), locs)
        CircuitStyles.render(c.gatestyles.line, c[(c.frontier[j], j); (ipre+ncolumn, j)])
        c.frontier[j] = ipre + ncolumn
    end
end

function text_width_and_size(text)
    lines = split(text, "\n")
    widths = map(x->textwidth(x), lines)
    (mw, loc) = findmax(widths)
    fontsize = mw > 3 ? CircuitStyles.paramtextsize[] : CircuitStyles.textsize[]
    # -2 because the gate has a default size
    #width = max(W - 4, 0) * fontsize * 0.016  # mm to cm
    Luxor.fontsize(fontsize)
    Luxor.fontface(CircuitStyles.fontfamily[])
    width, height = Luxor.textextents(lines[loc])[3:4]
    w = max(width / CircuitStyles.unit[] - CircuitStyles.r[]*2 + 0.2, 0.0)
    return w, fontsize
end

function initialize!(c::CircuitGrid; starting_texts, starting_offset)
    starting_texts !== nothing && for j=1:nline(c)
        CircuitStyles.render(c.gatestyles.text, (c[starting_offset, j], string(starting_texts[j]), c.w_depth, c.w_line))
    end
end

function finalize!(c::CircuitGrid; show_ending_bar, ending_offset, ending_texts)
    i = frontier(c, 1, nline(c))
    for j=1:nline(c)
        show_ending_bar && CircuitStyles.render(c.gatestyles.line, c[(i, j-0.2); (i, j+0.2)])
        CircuitStyles.render(c.gatestyles.line, c[(i, j); (c.frontier[j], j)])
        ending_texts !== nothing && CircuitStyles.render(c.gatestyles.text, (c[i+ending_offset, j], string(ending_texts[j]), c.w_depth, c.w_line))
    end
end

# elementary
function draw!(c::CircuitGrid, p::PrimitiveBlock, address, controls)
    bts = length(controls)>=1 ? get_cbrush_texts(c, p) : get_brush_texts(c, p)
    _draw!(c, [controls..., (getindex.(Ref(address), occupied_locs(p)), bts[1], bts[2])])
end
function draw!(c::CircuitGrid, p::Daggered{<:PrimitiveBlock}, address, controls)
    bts = length(controls)>=1 ? get_cbrush_texts(c, content(p)) : get_brush_texts(c, content(p))
    _draw!(c, [controls..., (getindex.(Ref(address), occupied_locs(p)), bts[1], bts[2]*"'")])
end
function draw!(c::CircuitGrid, p::UnitaryChannel, address, controls)
    bts = (c.gatestyles.g, "*")
    _draw!(c, [controls..., (getindex.(Ref(address), occupied_locs(p)), bts[1], bts[2])])
end

function draw!(c::CircuitGrid, p::Scale, address, controls)
    fp = YaoBlocks.factor(p)
    if !(abs(fp) ≈ 1)
        error("can not visualize non-phase factor.")
    end
    draw!(c, YaoBlocks.phase(angle(fp)), [first(address)], controls)
    draw!(c, p.content, address, controls)
end
# Special primitive gates
function draw!(c::CircuitGrid, ::I2Gate, address, controls)
    return
end
function draw!(c::CircuitGrid, ::IdentityGate, address, controls)
    return
end
function draw!(c::CircuitGrid, p::ConstGate.SWAPGate, address, controls)
    bts = [(c.gatestyles.x, ""), (c.gatestyles.x, "")]
    _draw!(c, [controls..., [(address[l], bt...) for (l, bt) in zip(occupied_locs(p), bts)]...])
end
function draw!(c::CircuitGrid, p::ConstGate.CNOTGate, address, controls)
    bts = [(c.gatestyles.c, ""), (c.gatestyles.x, "")]
    _draw!(c, [controls..., [(address[l], bt...) for (l, bt) in zip(occupied_locs(p), bts)]...])
end
function draw!(c::CircuitGrid, p::ConstGate.CZGate, address, controls)
    bts = [(c.gatestyles.c, ""), (c.gatestyles.c, "")]
    _draw!(c, [controls..., [(address[l], bt...) for (l, bt) in zip(occupied_locs(p), bts)]...])
end
function draw!(c::CircuitGrid, p::ConstGate.ToffoliGate, address, controls)
    bts = [(c.gatestyles.c, ""), (c.gatestyles.c, ""), (c.gatestyles.x, "")]
    _draw!(c, [controls..., [(address[l], bt...) for (l, bt) in zip(occupied_locs(p), bts)]...])
end

# composite
function draw!(c::CircuitGrid, p::ChainBlock, address, controls)
    CircuitStyles.barrier_for_chain[] && set_barrier!(c, Int[address..., controls...])
    for block in subblocks(p)
        draw!(c, block, address, controls)
    end
    CircuitStyles.barrier_for_chain[] && set_barrier!(c, Int[address..., controls...])
end

function set_barrier!(c::CircuitGrid, locs::AbstractVector{Int})
    front = maximum(c.frontier[locs])
    for loc in locs
        if c.frontier[loc] < front
            CircuitStyles.render(c.gatestyles.line, c[(c.frontier[loc], loc); (front, loc)])
            c.frontier[loc] = front
        end
    end
end

function draw!(c::CircuitGrid, p::PutBlock, address, controls)
    locs = [address[i] for i in p.locs]
    draw!(c, p.content, locs, controls)
end

function draw!(c::CircuitGrid, m::YaoBlocks.Measure, address, controls)
    @assert length(controls) == 0
    if m.postprocess isa RemoveMeasured
        error("can not visualize post-processing: `RemoveMeasured`.")
    end
    if !(m.operator isa ComputationalBasis)
        error("can not visualize measure blocks for operators")
    end
    locs = m.locations isa AllLocs ? collect(1:nqudits(m)) : [address[i] for i in m.locations]
    for (i, loc) in enumerate(locs)
        _draw!(c, [(loc, c.gatestyles.measure, "")])
        if m.postprocess isa ResetTo
            # read i-th bit value
            val = Int(m.postprocess.x)>>(i-1) & 1
            _draw!(c, [(loc, c.gatestyles.g, val == 1 ? "P₁" : "P₀")])
        end
    end
end

function draw!(c::CircuitGrid, cb::ControlBlock{GT,C}, address, controls) where {GT,C}
    ctrl_locs = [address[i] for i in cb.ctrl_locs]
    locs = [address[i] for i in cb.locs]
    mycontrols = [(loc, (bit == 1 ? c.gatestyles.c : c.gatestyles.nc), "") for (loc, bit)=zip(ctrl_locs, cb.ctrl_config)]
    draw!(c, cb.content, locs, [controls..., mycontrols...])
end

for B in [:GeneralMatrixBlock, :Add]
    @eval function draw!(c::CircuitGrid, cb::$B, address, controls)
        length(address) == 0 && return
        _draw!(c, [controls..., (address, c.gatestyles.g, string(cb))])
    end
end

function draw!(c::CircuitGrid, cb::LabelBlock, address, controls)
    length(address) == 0 && return
    CircuitStyles.gate_bgcolor[], temp = cb.color, CircuitStyles.gate_bgcolor[]
    _draw!(c, [controls..., (address, c.gatestyles.g, string(cb))])
    CircuitStyles.gate_bgcolor[] = temp
end

function draw!(c::CircuitGrid, cb::LineAnnotation, address, controls)
    @assert length(address) == 1 && isempty(controls) "LineAnnotation should be a single line, without control."
    CircuitStyles.textcolor[], temp = cb.color, CircuitStyles.textcolor[]
    _annotate!(c, address[1], cb.name)
    CircuitStyles.textcolor[] = temp
end
function _annotate!(c::CircuitGrid, loc::Integer, name::AbstractString)
    wspace, fontsize = text_width_and_size(name)
    i = frontier(c, loc) + 0.1
    CircuitStyles.render(CircuitStyles.Text(fontsize), (c[i, loc-0.2], name, wspace, fontsize))
end

# [:KronBlock, :RepeatedBlock, :CachedBlock, :Subroutine, :(YaoBlocks.AD.NoParams)]
function draw!(c::CircuitGrid, p::CompositeBlock, address, controls)
    barrier_style = CircuitStyles.barrier_for_chain[]
    CircuitStyles.barrier_for_chain[] = false
    draw!(c, YaoBlocks.Optimise.to_basictypes(p), address, controls)
    CircuitStyles.barrier_for_chain[] = barrier_style
end
for (GATE, SYM) in [(:XGate, :Rx), (:YGate, :Ry), (:ZGate, :Rz)]
    @eval get_brush_texts(c, b::RotationGate{D,T,<:$GATE}) where {D,T} = (c.gatestyles.g, "$($(SYM))($(pretty_angle(b.theta)))")
end

pretty_angle(theta) = string(theta)
function pretty_angle(theta::AbstractFloat)
    c = continued_fraction(theta/π, 10)
    if c.den < 100
        res = if c.num == 1
            "π"
        elseif c.num==0
            "0"
        elseif c.num==-1
            "-π"
        else
            "$(c.num)π"
        end
        if c.den != 1
            res *= "/$(c.den)"
        end
        res
    else
        "$(round(theta; digits=2))"
    end
end
"""
    continued_fraction(ϕ, n::Int) -> Rational

Obtain `s` and `r` from `ϕ` that satisfies `|s//r - ϕ| ≦ 1/2r²`
"""
function continued_fraction(fl, n::Int)
    if n == 1 || abs(mod(fl, 1)) < 1e-10
        Rational(floor(Int, fl), 1)
    else
        floor(Int, fl) + 1//continued_fraction(1/mod(fl, 1), n-1)
    end
end

get_brush_texts(c, ::ConstGate.SdagGate) = (c.gatestyles.g, "S'")
get_brush_texts(c, ::ConstGate.TdagGate) = (c.gatestyles.g, "T'")
get_brush_texts(c, ::ConstGate.PuGate) = (c.gatestyles.g, "P+")
get_brush_texts(c, ::ConstGate.PdGate) = (c.gatestyles.g, "P-")
get_brush_texts(c, ::ConstGate.P0Gate) = (c.gatestyles.g, "P₀")
get_brush_texts(c, ::ConstGate.P1Gate) = (c.gatestyles.g, "P₁")
get_brush_texts(c, b::PrimitiveBlock) = (c.gatestyles.g, string(b))
get_brush_texts(c, b::TimeEvolution) = (c.gatestyles.g, string(b))
get_brush_texts(c, b::ShiftGate) = (c.gatestyles.g, "φ($(pretty_angle(b.theta)))")
get_brush_texts(c, b::PhaseGate) = (CircuitStyles.Phase("$(pretty_angle(b.theta))"), "")
function get_brush_texts(c, b::T) where T<:ConstantGate
    namestr = string(T.name.name)
    if endswith(namestr, "Gate")
        namestr = namestr[1:end-4]
    end
    # Fix!
    (c.gatestyles.g, namestr)
end

get_cbrush_texts(c, b::PrimitiveBlock) = get_brush_texts(c, b)
get_cbrush_texts(c, ::XGate) = (c.gatestyles.not, "")
get_cbrush_texts(c, ::ZGate) = (c.gatestyles.c, "")

# front end
"""
    vizcircuit(circuit; w_depth=0.85, w_line=0.75, format=:svg, filename=nothing,
        show_ending_bar=false, starting_texts=nothing, starting_offset=-0.3,
        ending_texts=nothing, ending_offset=0.3)

Visualize a `Yao` quantum circuit.

### Keyword Arguments
* `w_depth` is the circuit column width.
* `w_line` is the circuit row width.
* `format` can be `:svg`, `:png` or `:pdf`.
* `filename` can be `"*.svg"`, `"*.png"`, `"*.pdf"` or nothing (not saving to a file).
* `starting_texts` and `ending_texts` are texts shown before and after the circuit.
* `starting_offset` and `end_offset` are offsets (real values) for starting and ending texts.
* `show_ending_bar` is a boolean switch to show ending bar.

### Styles
To change the gates styles like colors and lines, please modify the constants in submodule `CircuitStyles`.
They are defined as:

* CircuitStyles.unit = Ref(60)                      # number of points in a unit
* CircuitStyles.r = Ref(0.2)                        # size of nodes
* CircuitStyles.lw = Ref(1.0)                       # line width
* CircuitStyles.textsize = Ref(16.0)                # text size
* CircuitStyles.paramtextsize = Ref(10.0)           # text size (longer texts)
* CircuitStyles.fontfamily = Ref("JuliaMono")       # font family
* CircuitStyles.linecolor = Ref("#000000")          # line color
* CircuitStyles.gate_bgcolor = Ref("transparent")   # gate background color
* CircuitStyles.textcolor = Ref("#000000")          # text color
"""
function vizcircuit(blk::AbstractBlock; w_depth=0.85, w_line=0.75, format=:svg, filename=nothing,
        show_ending_bar=false, starting_texts=nothing, starting_offset=-0.3,
        ending_texts=nothing, ending_offset=0.3, gatestyles=CircuitStyles.GateStyles())
    img = circuit_canvas(nqudits(blk); w_depth, w_line, show_ending_bar, starting_texts, starting_offset,
            ending_texts, ending_offset, gatestyles, format, filename) do c
        addblock!(c, blk)
    end
    return img
end

addblock!(c::CircuitGrid, blk::AbstractBlock) = draw!(c, blk, collect(1:nqudits(blk)), [])
addblock!(c::CircuitGrid, blk::Function) = addblock!(c, blk(nline(c)))

function circuit_canvas(f, nline::Int; format=:svg, filename=nothing, w_depth=0.85, w_line=0.75,
        show_ending_bar=false, starting_texts=nothing, starting_offset=-0.3, ending_texts=nothing,
        ending_offset=0.3, gatestyles=CircuitStyles.GateStyles())
    # the first time to estimate the canvas size
    Luxor.Drawing(50, 50, :png)
    c = CircuitGrid(nline; w_depth, w_line, gatestyles)
    initialize!(c; starting_texts, starting_offset)
    f(c)
    finalize!(c; show_ending_bar, ending_texts, ending_offset)
    Luxor.finish()
    # the second time draw
    u = CircuitStyles.unit[]
    a, b = ceil(Int, (depth(c)+1)*w_depth*u), ceil(Int, nline*w_line*u)
    _luxor(a, b, w_depth/2*u, -w_line/2*u; format, filename) do
        c = CircuitGrid(nline; w_depth, w_line, gatestyles)
        initialize!(c; starting_texts, starting_offset)
        f(c)
        finalize!(c; show_ending_bar, ending_texts, ending_offset)
    end
end

function _luxor(f, Dx, Dy, offsetx, offsety; format, filename)
    if filename === nothing
        if format == :pdf
            _format = tempname()*".pdf"
        else
            _format = format
        end
    else
        _format = filename
    end
    Luxor.Drawing(round(Int,Dx), round(Int,Dy), _format)
    Luxor.origin(offsetx, offsety)
    f()
    Luxor.finish()
    Luxor.preview()
end

vizcircuit(; kwargs...) = c->vizcircuit(c; kwargs...)

"""
    darktheme!()

Change the default theme to dark.
"""
function darktheme!()
    CircuitStyles.linecolor[] = "#FFFFFF"
    CircuitStyles.textcolor[] = "#FFFFFF"
    BlochStyles.color[] = "#FFFFFF"
    BlochStyles.axes_colors .= ["#FFFFFF", "#FFFFFF", "#FFFFFF"]
end

"""
    lighttheme!()

Change the default theme to light.
"""
function lighttheme!()
    CircuitStyles.linecolor[] = "#000000"
    CircuitStyles.textcolor[] = "#000000"
    BlochStyles.color[] = "#000000"
    BlochStyles.axes_colors .= ["#000000", "#000000", "#000000"]
end

"""
    LabelBlock{BT,D} <: TagBlock{BT,D}

A marker to mark a circuit applying on a continous block for better plotting.

# Fields:
- `content`: the block to be labeled
- `name`: the name of the block
- `color`: the color of the block
- `toptext`: the text to be displayed at the top of the block
- `bottomtext`: the text to be displayed at the bottom of the block
"""
struct LabelBlock{BT<:AbstractBlock,D} <: TagBlock{BT,D}
    content::BT
    name::String
    color::String
    toptext::String
    bottomtext::String
end

YaoBlocks.content(cb::LabelBlock) = cb.content
function LabelBlock(x::BT, name::String, color::String, toptext::String, bottomtext::String) where {D,BT<:AbstractBlock{D}}
    LabelBlock{BT,D}(x, name, color, toptext, bottomtext)
end

function is_continuous_chunk(x)
    length(x) == 0 && return true
    return length(x) == maximum(x)-minimum(x)+1
end

YaoBlocks.PropertyTrait(::LabelBlock) = YaoBlocks.PreserveAll()
YaoBlocks.mat(::Type{T}, blk::LabelBlock) where {T} = mat(T, content(blk))
YaoBlocks.unsafe_apply!(reg::YaoBlocks.AbstractRegister, blk::LabelBlock) = YaoBlocks.unsafe_apply!(reg, content(blk))
YaoBlocks.chsubblocks(blk::LabelBlock, target::AbstractBlock) = LabelBlock(target, blk.name, blk.color, blk.toptext, blk.bottomtext)

Base.adjoint(x::LabelBlock) = LabelBlock(adjoint(content(x)), endswith(x.name, "†") ? x.name[1:end-1] : x.name*"†", x.color, x.bottomtext, x.toptext)
Base.copy(x::LabelBlock) = LabelBlock(copy(content(x)), x.name, x.color, x.toptext, x.bottomtext)
YaoBlocks.Optimise.to_basictypes(block::LabelBlock) = block

addlabel(b::AbstractBlock; name=string(b), color="transparent", toptext="", bottomtext="") = LabelBlock(b, name, color, toptext, bottomtext)

# to fix issue 
function YaoBlocks.print_tree(
   io::IO,
   root::AbstractBlock,
   node::LabelBlock,
   depth::Int = 1,
   islast::Bool = false,
   active_levels = ();
   maxdepth = 5,
   charset = YaoBlocks.BlockTreeCharSet(),
   title = true,
   compact = false,
)
   print(io, node.name)
end

"""
    LineAnnotation{D} <: TrivialGate{D}
"""
struct LineAnnotation{D} <: TrivialGate{D}
    name::String
    color::String
end
line_annotation(name::String; color="black", nlevel=2) = LineAnnotation{nlevel}(name, color)

Base.copy(x::LineAnnotation) = LineAnnotation(x.name, x.color)
YaoBlocks.Optimise.to_basictypes(block::LineAnnotation) = block
YaoBlocks.nqudits(::LineAnnotation) = 1
YaoBlocks.print_block(io::IO, blk::LineAnnotation) = YaoBlocks.printstyled(io, blk.name; color=Symbol(blk.color))

using YaoPlots
using Test

@testset "helperblock" begin
    include("helperblock.jl")
end

@testset "vizcircuit" begin
    include("vizcircuit.jl")
end

@testset "bloch" begin
    include("bloch.jl")
end

using Yao, YaoPlots, Yao.EasyBuild
N = 4
d = 1
ising(nbit, i, j) = rot(kron(nbit, i=>X, j=>X), 0.0)
circuit = dispatch!(variational_circuit(N, d, pair_ring(N), entangler=ising), :zero)

circuit |> vizcircuit(scale=0.7)

using YaoPlots
using Test
using YaoBlocks
using YaoPlots: addblock!, CircuitGrid, circuit_canvas
using YaoArrayRegister
using Luxor

@testset "gate styles" begin
    c = YaoPlots.CircuitGrid(1)
    @test YaoPlots.get_brush_texts(c, X)[2] == "X"
    @test YaoPlots.get_brush_texts(c, Rx(0.5))[2] == "Rx(0.5)"
    @test YaoPlots.get_brush_texts(c, shift(0.5))[2] == "φ(0.5)"
    @test YaoPlots.get_brush_texts(c, YaoBlocks.phase(0.5))[2] == ""
end

@testset "circuit canvas" begin
    c = CircuitGrid(5)
    @test YaoPlots.nline(c) == 5
    @test YaoPlots.frontier(c, 2, 3) == 0
    @test YaoPlots.depth(c) == 0
    circuit_canvas(5) do c
        YaoPlots.draw!(c, put(5, 3=>X), 1:5, [])
        @test YaoPlots.frontier(c, 1, 2) == 0
        @test YaoPlots.frontier(c, 3, 5) == 1
        @test YaoPlots.depth(c) == 1
    end

    gg = circuit_canvas(5) do c
        addblock!(c, put(3=>X))
        addblock!(c, put(3=>matblock(rand_unitary(2); tag="xxx")))
        addblock!(c, put(3=>igate(1)))
        addblock!(c, time_evolve(put(3,3=>igate(1)), 0.1))
        addblock!(c, control(2, 3=>X))
        addblock!(c, control(2, 3=>shift(0.5)))
        addblock!(c, chain(5, control(2, 3=>X), put(1=>X)))
        @test YaoPlots.depth(c) >= 6
    end
    @test gg isa Drawing

    g = put(5, (3, 4)=>SWAP) |> vizcircuit(; w_line=0.8, w_depth=0.9)
    @test g isa Drawing
    @test vizcircuit(put(5, (3,4)=>kron(X, Y)); w_line=0.8, w_depth=0.9) isa Drawing

    @test vizcircuit(control(10, (2, -3), 6=>X)) isa Drawing
    @test vizcircuit(control(10, (2, -3), 6=>im*X)) isa Drawing
    @test plot(put(7, (2,3)=>matblock(randn(4,4)))) isa Drawing
    # qudit
    @test vizcircuit(put(10, 6=>matblock(rand_unitary(3); nlevel=3, tag="3 level"))) isa Drawing
end

@testset "fix #3" begin
    @test (control(4, 2, (1,3)=>kron(X, X)) |> vizcircuit) isa Drawing
end

@testset "pretty_angle" begin
    @test YaoPlots.pretty_angle(π) == "π"
    @test YaoPlots.pretty_angle(π*1.0) == "π"
    @test YaoPlots.pretty_angle(-π*1.0) == "-π"
    @test YaoPlots.pretty_angle(-π*0.0) == "0"
    @test YaoPlots.pretty_angle(-π*0.5) == "-π/2"
    @test YaoPlots.pretty_angle(1.411110) == "1.41"
end

@testset "readme" begin
    YaoPlots.CircuitStyles.linecolor[] = "pink" 
    YaoPlots.CircuitStyles.gate_bgcolor[] = "yellow" 
    YaoPlots.CircuitStyles.textcolor[] = "#000080" # the navy blue color
    YaoPlots.CircuitStyles.fontfamily[] = "JuliaMono"
    YaoPlots.CircuitStyles.lw[] = 2.5
    YaoPlots.CircuitStyles.textsize[] = 13
    YaoPlots.CircuitStyles.paramtextsize[] = 8
            
    @test plot(chain(3, put(1=>X), repeat(3, H), put(2=>Y), repeat(3, Rx(π/2)))) isa Drawing
    darktheme!()
    @test plot(chain(3, put(1=>X), repeat(3, H), put(2=>Y), repeat(3, Rx(π/2)))) isa Drawing
    lighttheme!()
    @test plot(chain(3, put(1=>X), repeat(3, H), put(2=>Y), repeat(3, Rx(π/2)))) isa Drawing
end

@testset "readme" begin
    circuit = chain(
        4,    
        kron(X, H, H, H),
        kron(1=>Y, 4=>H), 
        put(2=>Y),
    )
    YaoPlots.CircuitStyles.barrier_for_chain[] = true
    @test vizcircuit(circuit) isa Drawing
end

@testset "rot igate" begin
    @test plot(rot(igate(1), 1.)) isa Drawing
    @test plot(rot(put(3, 1=>X), 1.)) isa Drawing
end

@testset "issue 558" begin
    qc = chain(2)
    push!(qc,put(2,1 => Measure(1)))
    push!(qc,put(2,2 => Measure(1)))
    @test vizcircuit(qc) isa Drawing
end


@testset "noise channel" begin
    c1 = quantum_channel(DepolarizingError(1, 0.1))
    c2 = quantum_channel(PhaseFlipError(0.1))
    c3 = quantum_channel(AmplitudeDampingError(0.1))
    c4 = SuperOp(quantum_channel(ResetError(0.1, 0.0)))
    grid = CircuitGrid(2)
    @test YaoPlots.get_brush_texts(grid, c1) == (grid.gatestyles.g, "DEP(0.1)")
    @test YaoPlots.get_brush_texts(grid, c2) == (grid.gatestyles.g, "MU(0.9*I2, 0.1*Z)")
    @test YaoPlots.get_brush_texts(grid, c3) == (grid.gatestyles.g, "KR(A0, A1)")
    @test YaoPlots.get_brush_texts(grid, c4) == (grid.gatestyles.g, "CHN")

    circuit = chain(
        2,
        put(1=>c1),
        put(2=>c2),
        put(2=>c3),
        put(2=>c4),
    )
    @test plot(circuit) isa Drawing
end

@testset "fix #563 - measure" begin
    c = chain(5, Measure(5; locs=(2,), error_prob=0.1, operator=X))
    res = vizcircuit(c)
    @test res isa Drawing
    display(res)
    res = vizcircuit(depolarizing_channel(2, p=0.2))
    @test res isa Drawing
    display(res)
    res = vizcircuit(put(2, 1=>addlabel(X; name="X", toptext="rec[1]\n3", bottomtext="p = 0.01")))
    @test res isa Drawing
    display(res)
end

using YaoPlots, Yao
using LinearAlgebra: axpy!

function commutator(x, y; ishermitian=false)
    res = x * y
    if ishermitian
        return res - res'
    else
        return res - y * x
    end
end
function anticommutator(x, y; ishermitian=false)
    res = x * y
    if ishermitian
        return res + res'
    else
        return res + y * x
    end
end

# single step master equation
function mestep(rho::DensityMatrix{D}, h, Ls, dt) where D
    res = copy(rho.state)
    # The im*[ρ, H] term.
    # NOTE: transposed storage is faster
    reg = arrayreg(copy(rho.state)'; nlevel=size(rho.state, 2))
    apply!(reg, h)
    axpy!(dt * im, reg.state' - reg.state, res)
    for L in Ls
        # the LρL' term
        axpy!(dt, apply(rho, L).state, res)
        # the -(ρL'L + L'Lρ)/2 term
        reg = arrayreg(copy(rho.state)'; nlevel=size(rho.state, 2))
        apply!(reg, L' * L)
        axpy!(-0.5dt, reg.state, res)
        axpy!(-0.5dt, reg.state', res)
    end
    return DensityMatrix(res)
end

function simulate(t; dt=0.02, dissiplation=0.2, filename=nothing)
    reg0 = zero_state(1) |> H
    rho = density_matrix(reg0)
    h = Z    # rotate around Z
    Ls = [sqrt(dissiplation) * ConstGate.Pd]  # dissipation
    states = ["|+⟩"=>rho]
    for t = 0:dt:t
        rho = mestep(rho, h, Ls, dt)
        push!(states, ""=>rho)
    end
    return bloch_sphere(states...; filename)
end

simulate(π/2; filename=joinpath(@__DIR__, "mesolve.png"))

module YaoPlots

using YaoBlocks
using YaoBlocks.DocStringExtensions
using YaoArrayRegister
import Luxor
using Luxor: @layer, Point
using LinearAlgebra: tr
using YaoBlocks

export CircuitStyles, vizcircuit, darktheme!, lighttheme!
export bloch_sphere, BlochStyles
export plot
export LabelBlock, addlabel, LineAnnotation, line_annotation

"""An alias of `vizcircuit`"""
plot(;kwargs...) = x->plot(x;kwargs...)
plot(blk::AbstractBlock; kwargs...) = vizcircuit(blk; kwargs...)

include("helperblock.jl")
include("vizcircuit.jl")
include("3d.jl")
using .Thebes: Point3D, project
include("bloch.jl")

end

using YaoPlots, Test
using LinearAlgebra: normalize!, eigen
using Luxor: Drawing
using YaoBlocks
using YaoArrayRegister

@testset "spherical coo" begin
    for i=1:10
        x = randn(3)
        @test collect(YaoPlots.polar_to_cartesian(YaoPlots.cartesian_to_polar(x...)...)) ≈ x
    end
end

@testset "state to polar" begin
    nx, ny, nz = normalize!(randn(3))
    sigma = nx * X + ny * Y + nz * Z
    m = Matrix(sigma)
    E, U = eigen(m)
    @test collect(YaoPlots.state_to_cartesian(U[:, 2])) ≈ [nx, ny, nz]
    @test collect(YaoPlots.state_to_cartesian(U[:, 1])) ≈ -[nx, ny, nz]

    reg = rand_state(1)
    @test collect(YaoPlots.state_to_cartesian(reg)) ≈ collect(YaoPlots.state_to_cartesian(density_matrix(reg)))
end

@testset "bloch" begin
    @test bloch_sphere("|ψ⟩"=>[2.2, 0.3im+0.3]; show_projection_lines=true,
        show_angle_texts=true, show_line=true, show01=true) isa Drawing
    # dark theme
    darktheme!()
    @test bloch_sphere("|ψ⟩"=>[2.2, 0.3im+0.3]; show_projection_lines=true,
        show_angle_texts=true, show_line=true, show01=true) isa Drawing
end

@testset "draw reg" begin
    @test bloch_sphere("|ψ⟩"=>rand_state(1)) isa Drawing
end

@testset "draw density matrix" begin
    rho = density_matrix(rand_state(2), 1)
    @test bloch_sphere("ρ"=>rho) isa Drawing
    bloch_sphere("|ψ⟩"=>rand_state(1), "ρ"=>density_matrix(rand_state(2), 1))
end

using YaoPlots, YaoBlocks, Luxor
using YaoArrayRegister
using Test

@testset "LabelBlock" begin
    x = put(5, (2,3)=>matblock(rand_unitary(4)))
    cb = LabelBlock(x, "x", "red", "", "")
    @test mat(copy(cb)) == mat(cb)
    @test isunitary(cb)
    @test ishermitian(cb) == ishermitian(x)
    @test isreflexive(cb) == isreflexive(x)
    @test mat(cb) == mat(x)
    reg = rand_state(5)
    @test apply!(copy(reg), cb) ≈ apply!(copy(reg), x)
    @test cb' isa LabelBlock && mat(cb') ≈ mat(cb)'
    @test (cb').name == "x†" && (cb'').name == "x"

    y = put(5, (3,4)=>matblock(rand_unitary(4)))
    cc = chsubblocks(cb, y)
    @test YaoPlots.is_continuous_chunk([1,2,3]) == true
    @test YaoPlots.is_continuous_chunk([1,2,4]) == false
    @test YaoPlots.is_continuous_chunk([3,2,4]) == true
    
    c1 = chain(5, [put(5, (2,3)=>addlabel(SWAP; name="SWAP")), put(5, 2=>addlabel(I2; name="id")), put(5, 2=>addlabel(X; name="X")), control(5, (5,3), (2,4,1)=>put(3, (1,3)=>addlabel(SWAP; name="SWAP")))])
    c2 = chain(5, [put(5, (2,3)=>addlabel(SWAP; name="SWAP")), put(5, 2=>addlabel(I2; name="id")), put(5, 2=>addlabel(X; name="X")), control(5, (5,3), (2,4,1)=>put(3, (1,2)=>addlabel(SWAP; name="SWAP")))])

    @test vizcircuit(c1) isa Drawing
    @test vizcircuit(c2) isa Drawing
end

@testset "annotate line" begin
    ann = line_annotation("test"; color="red")
    @test ann isa LineAnnotation
    c = chain(put(5, 2=>X), put(5, 2=>ann),  put(5, 3=>Y))
    @test vizcircuit(c) isa Drawing
end

using Yao.EasyBuild, YaoPlots, Yao

lighttheme!()
YaoPlots.CircuitStyles.gate_bgcolor[] = "white"  # default is transparent
# qft circuit
vizcircuit(qft_circuit(5); filename=joinpath(@__DIR__, "qft.png"))

# labeled and time evolution
vizcircuit(chain(control(5, 3, (2,4)=>matblock(rand_unitary(4); tag="label")),
    put(5, (2,4)=>matblock(rand_unitary(4); tag="labellabel")), time_evolve(+(put(5, 2=>X), kron(5, 2=>Z, 3=>Y)), 0.2)), filename=joinpath(@__DIR__, "labelled.png"))

# variational circuit
vizcircuit(variational_circuit(5), filename=joinpath(@__DIR__, "variational.png"))
# vizcircuit(variational_circuit(5; mode=:Merged))

# general U4 gate
vizcircuit(general_U4(), filename=joinpath(@__DIR__, "u4.png"))

# quantum supremacy circuit
vizcircuit(rand_supremacy2d(2, 2, 8), filename=joinpath(@__DIR__, "supremacy2d.png"))

# google 52 qubit
vizcircuit(rand_google53(5); filename=joinpath(@__DIR__, "google53.png"))

# control blocks
vizcircuit(chain(control(5, (2,-3), 4=>X), control(5, (-4, -2), 1=>Z)), filename=joinpath(@__DIR__, "controls.png"))

# controlled kron
vizcircuit(control(4, 2, (1, 3)=>kron(X, X)), filename=joinpath(@__DIR__, "cxx.png"))

vizcircuit(control(4, -collect(1:4-1), 4=>-Z), filename=joinpath(@__DIR__, "reflect.png"))

vizcircuit(chain(5, [put(5, 2=>X), Yao.Measure(5; locs=(2,3)), Yao.Measure(5;locs=(2,)), Yao.Measure(5; resetto=bit"00110")]), filename=joinpath(@__DIR__, "measure.png"))

vizcircuit(chain(5, [put(5, 2=>ConstGate.Sdag), put(5, 3=>ConstGate.Tdag),
    put(5, (2,3)=>ConstGate.CNOT), put(5, (1,4)=>ConstGate.CZ), put(5, (1,2,5)=>ConstGate.Toffoli),
    put(5, (2,3)=>ConstGate.SWAP), put(5, (1,)=>ConstGate.P0), put(5, (1,)=>ConstGate.I2),
    put(5, (2,)=>ConstGate.P1), put(5, (1,)=>ConstGate.Pu), put(5, (1,)=>ConstGate.Pd),
    put(5, (2,)=>ConstGate.T),
    put(5, (2,)=>phase(0.4π)),
    put(5, (2,)=>shift(0.4π)),
    ]), filename=joinpath(@__DIR__, "constgates.png"))

vizcircuit(chain(5, [put(5, (2,3)=>matblock(Matrix(SWAP), tag="SWAP")'), put(5, 2=>matblock(mat(I2), tag="id")), put(5, 2=>addlabel(X, "Xr")), control(5, (5,3), (2,4,1)=>put(3, (1,3)=>addlabel(SWAP, "SWAP")))]), filename=joinpath(@__DIR__, "multiqubit.png"))

YaoPlots.darktheme!()
YaoPlots.CircuitStyles.gate_bgcolor[] = "transparent"  # default is transparent
# qft circuit
vizcircuit(qft_circuit(5), filename=joinpath(@__DIR__, "qft-white.png"))

# The following code is copied from Thebes.jl, which is a package for 3D plotting in Julia.
# Since Thebes.jl is not updated for a while, we need to update the code to make it work with the latest version of Luxor.jl.

module Thebes
using Luxor
struct Point3D
    x::Float64
    y::Float64
    z::Float64
end

mutable struct Projection
    U::Point3D     #
    V::Point3D     #
    W::Point3D     #
    ue::Float64    #
    ve::Float64    #
    we::Float64    #
    eyepoint::Point3D
    centerpoint::Point3D
    uppoint::Point3D
    perspective::Float64 #
end

function newprojection(ipos::Point3D, center::Point3D, up::Point3D, perspective=0.0)
    if iszero(ipos.x)
        ipos = Point3D(10e-9, ipos.y, ipos.z)
    end  
    if iszero(ipos.y)
        ipos = Point3D(ipos.x, 10e-9, ipos.z)
    end  
    if iszero(ipos.z)
        ipos = Point3D(ipos.x, ipos.y, 10e-9)
    end  

    # w is the line of sight
    W = Point3D(center.x - ipos.x, center.y - ipos.y, center.z - ipos.z)
    r = (W.x * W.x) + (W.y * W.y) + (W.z * W.z)
    if r < eps()
        @info("eye position and center are the same")
        
        W = Point3D(0.0, 0.0, 0.0)
    else
        # distancealise w to unit length
        rinv = 1 / sqrt(r)
        W = Point3D(W.x * rinv, W.y * rinv, W.z * rinv)
    end
    we = W.x * ipos.x + W.y * ipos.y + W.z * ipos.z # project e on to w
    U = Point3D(W.y * (up.z - ipos.z) - W.z * (up.y - ipos.y),      # u is at right angles to t - e
        W.z * (up.x - ipos.x) - W.x * (up.z - ipos.z),      # and w ., its' the pictures x axis
        W.x * (up.y - ipos.y) - W.y * (up.x - ipos.x))
    r = (U.x * U.x) + (U.y * U.y) + (U.z * U.z)

    if r < eps()
        @info("struggling to make a valid projection with these parameters")
        U = Point3D(0.0, 0.0, 0.0)
    else
        rinv = 1 / sqrt(r) # distancealise u
        U = Point3D(U.x * rinv, U.y * rinv, U.z * rinv)
    end

    ue = U.x * ipos.x + U.y * ipos.y + U.z * ipos.z # project e onto u

    V = Point3D(U.y * W.z - U.z * W.y, # v is at right angles to u and w
        U.z * W.x - U.x * W.z, # it's the world's y axis
        U.x * W.y - U.y * W.x)

    ve = V.x * ipos.x + V.y * ipos.y + V.z * ipos.z # project e onto v

    Projection(U, V, W, ue, ve, we, ipos, center, up, perspective)
end

function project(proj::Projection, P::Point3D)
    # use default value for perspectiveness if not specified
    r = proj.W.x * P.x + proj.W.y * P.y + proj.W.z * P.z - proj.we
    if r < eps()
        # "point $P is behind eye"
        result = nothing
    else
        if proj.perspective == 0.0
            depth = 1
        else
            depth = proj.perspective * (1 / r)
        end
        uq = depth * (proj.U.x * P.x + proj.U.y * P.y + proj.U.z * P.z - proj.ue)
        vq = depth * (proj.V.x * P.x + proj.V.y * P.y + proj.V.z * P.z - proj.ve)
        result = Point(uq, -vq) # because Y is down the page in Luxor (?!)
    end
    return result
end

function eyepoint(pt::Point3D)
    return newprojection(pt, Point3D(0, 0, 0), Point3D(0, 0, 1))
end

function Luxor.distance(p1::Point3D, p2::Point3D)
    sqrt((p2.x - p1.x)^2 + (p2.y - p1.y)^2 + (p2.z - p1.z)^2)
end

end

"""
    BlochStyles

The module to define the default styles for bloch sphere drawing.
To change the default styles, you can modify the values in this module, e.g.
```julia
using YaoPlots
YaoPlots.BlochStyles.lw[] = 2.0
```

### Style variables
#### Generic
- `lw`: the line width of the drawing
- `textsize`: the size of the text
- `fontfamily`: the font family of the text
- `background_color`: the background color of the drawing
- `color`: the color of the drawing

#### Sphere
- `ball_size`: the size of the ball
- `dot_size`: the size of the dot
- `eye_point`: the eye point of the drawing

#### Axis
- `axes_lw`: the line width of the axes
- `axes_colors`: the colors of the axes
- `axes_texts`: the texts of the axes, default to `["x", "y", "z"]`

#### State display
- `show_projection_lines`: whether to show the projection lines
- `show_angle_texts`: whether to show the angle texts
- `show_line`: whether to show the line
- `show01`: whether to show the 0 and 1 states
"""
module BlochStyles
    using Luxor
    # generic config
    const lw = Ref(1.0)
    const textsize = Ref(16.0)
    const fontfamily = Ref("JuliaMono")
    const background_color = Ref("transparent")
    const color = Ref("#000000")

    # bloch sphere config
    const ball_size = Ref(100)
    const dot_size = Ref(3)
    const eye_point = Ref((500, 200, 200))

    # axes config
    const axes_lw = Ref(1.0)
    const axes_colors = ["#000000", "#000000", "#000000"]
    const axes_texts = ["x", "y", "z"]

    # state display config
    const show_projection_lines = Ref(false)
    const show_angle_texts = Ref(false)
    const show_line = Ref(true)
    const show01 = Ref(false)
end

"""
$TYPEDSIGNATURES

Draw a bloch sphere, with the inputs being a list of `string => state` pairs,
where the string is a label for the state and a state can be a complex vector of size 2, a Yao register or `DensityMatrix`.
If you want to get a raw drawing, use `draw_bloch_sphere` instead.

### Keyword Arguments
Note: The default values can be specified in submodule `BlochStyles`.

- `textsize`: the size of the text
- `color`: the color of the drawing
- `drawing_size`: the size of the drawing
- `offset_x`: the offset of the drawing in x direction
- `offset_y`: the offset of the drawing in y direction
- `filename`: the filename of the output file, if not specified, a temporary file will be used
- `format`: the format of the output file, if not specified, the format will be inferred from the filename
- `fontfamily`: the font family of the text
- `background_color`: the background color of the drawing
- `lw`: the line width of the drawing
- `eye_point`: the eye point of the drawing
- `extra_kwargs`: extra keyword arguments passed to `draw_bloch_sphere`
    - `dot_size`: the size of the dot
    - `ball_size`: the size of the ball
    - `show_projection_lines`: whether to show the projection lines
    - `show_angle_texts`: whether to show the angle texts
    - `show_line`: whether to show the line
    - `show01`: whether to show the 0 and 1 states
    - `colors`: the colors of the states
    - `axes_lw`: the line width of the axes
    - `axes_textsize`: the size of the axes texts
    - `axes_colors`: the colors of the axes
    - `axes_texts`: the texts of the axes

### Examples

```jldoctest
julia> using YaoPlots, YaoArrayRegister

julia> bloch_sphere("|ψ⟩"=>rand_state(1), "ρ"=>density_matrix(rand_state(2), 1));
```
"""
function bloch_sphere(states...;
        textsize=BlochStyles.textsize[],
        color = BlochStyles.color[],
        drawing_size = 300,
        offset_x = 0,
        offset_y = 0,
        filename = nothing,
        format = :svg,
        fontfamily = BlochStyles.fontfamily[],
        background_color = BlochStyles.background_color[],
        lw = BlochStyles.lw[],
        eye_point = BlochStyles.eye_point[],
        extra_kwargs...)

    # file format
    if filename === nothing
        if format == :pdf
            _format = tempname()*".pdf"
        else
            _format = format
        end
    else
        _format = filename
    end
    # Set up the drawing canvas
    Luxor.Drawing(drawing_size, drawing_size, _format)
    Luxor.origin(drawing_size/2 + offset_x, drawing_size/2 + offset_y)
    Luxor.background(background_color)
    Luxor.sethue(color)
    Luxor.fontsize(textsize)
    fontfamily !== nothing && Luxor.fontface(fontfamily)
    Luxor.setline(lw)
    draw_bloch_sphere(states...; eye_point, extra_kwargs...)

    # Save the drawing to a file
    Luxor.finish()
    Luxor.preview()
end

# draw bloch sphere at the origin
function draw_bloch_sphere(states::Pair{<:AbstractString}...;
        dot_size=BlochStyles.dot_size[],
        ball_size=BlochStyles.ball_size[],
        eye_point=BlochStyles.eye_point[],
        show_projection_lines = BlochStyles.show_projection_lines[],
        show_angle_texts = BlochStyles.show_angle_texts[],
        show_line = BlochStyles.show_line[],
        show01 = BlochStyles.show01[],
        colors = fill(BlochStyles.color[], length(states)),
        extra_kwargs...
    )
    proj = Thebes.eyepoint(Point3D(eye_point...))

    # get coordinate of a state
    getcoo(x) = Point3D((ball_size .* state_to_cartesian(x))...)

    # ball
    Luxor.circle(Point(0, 0), ball_size, :stroke)

    # equator
    nstep = 100
    equator_points = map(LinRange(0, 2π*(1-1/nstep), nstep)) do ϕ
        project(proj, Point3D((ball_size .* polar_to_cartesian(1.0, π/2, ϕ))...))
    end
    Luxor.line.(equator_points[1:2:end], equator_points[2:2:end], :stroke)

    # show axes
    axes3D(ball_size*3 ÷ 2; proj, extra_kwargs...)

    # show 01 states
    if show01
        for (txt, point) in [("|0⟩", [1, 0.0im]), ("|1⟩", [0.0im, 1])]
            p = getcoo(point)
            @layer begin
                Luxor.sethue(BlochStyles.color[])
                if Thebes.distance(Point3D(0, 0, 0), Point3D(eye_point...)) < Thebes.distance(p, Point3D(eye_point...))
                    Luxor.setopacity(0.3)
                end
                show_point(txt, project(proj, p); dot_size, text_offset=Point(10, 0), show_line=false)
            end
        end
    end

    # show points
    for ((txt, point), color) in zip(states, colors)
        p = getcoo(point)
        @layer begin
            Luxor.sethue(color)
            if Thebes.distance(Point3D(0, 0, 0), Point3D(eye_point...)) < Thebes.distance(p, Point3D(eye_point...))
                Luxor.setopacity(0.3)
            end
            show_point(txt, project(proj, p); dot_size, text_offset=Point(10, 0), show_line=show_line)
        end
        if show_projection_lines
            # show θ
            ratio = 0.2
            sz = project(proj, Point3D(0, 0, ball_size*ratio))
            if show_angle_texts
                Luxor.move(sz)
                Luxor.arc2r(Point(0, 0), sz, project(proj, p) * ratio, :stroke)
                Luxor.text("θ", sz - Point(0, ball_size*0.07))
            end
            # show equator projection and ϕ
            equatorp = Point3D(p.x, p.y, 0)
            sx = project(proj, Point3D(ball_size*ratio, 0, 0))
            
            if show_angle_texts
                Luxor.move(sx)
                Luxor.carc2r(Point(0, 0), sx, project(proj, equatorp) * ratio, :stroke)
                Luxor.text("ϕ", sx - Point(ball_size*0.12, 0))
            end

            @layer begin
                Luxor.setdash("dot")
                Luxor.setline(1)
                Luxor.line(project(proj, p), project(proj, equatorp), :stroke)
                Luxor.line(Point(0, 0), project(proj, equatorp), :stroke)
            end
        end
    end
end

function show_point(txt, p; dot_size, text_offset, show_line)
    Luxor.circle(p, dot_size, :fill)
    Luxor.text(txt, p + text_offset)
    show_line && Luxor.line(Point(0, 0), p, :stroke)
end

function polar_to_cartesian(r, θ, ϕ)
    x = r * sin(θ) * cos(ϕ)
    y = r * sin(θ) * sin(ϕ)
    z = r * cos(θ)
    return x, y, z
end

function cartesian_to_polar(x, y, z)
    r = sqrt(x^2 + y^2 + z^2)
    θ = acos(z/r)
    ϕ = atan(y, x)
    return r, θ, ϕ
end

function state_to_polar(state::AbstractVector{Complex{T}}) where T
    @assert length(state) == 2
    r = norm(state)
    ϕ = iszero(state[1]) ? zero(T) : angle(state[2]/state[1])
    θ = 2 * atan(abs(state[2]), abs(state[1]))
    return r, θ, ϕ
end
state_to_cartesian(state) = polar_to_cartesian(state_to_polar(state)...)

# Draw labelled 3D axes with length `n`.
function axes3D(n::Int;
        proj,
        axes_lw = BlochStyles.axes_lw[],
        axes_textsize = BlochStyles.textsize[],
        axes_colors = BlochStyles.axes_colors,
        axes_texts = BlochStyles.axes_texts,
        )
    @layer begin
        Luxor.fontsize(axes_textsize)
        Luxor.setline(axes_lw)
        for i = 1:3
            axis1 = project(proj, Point3D(0.1, 0.1, 0.1))
            axis2 = [0.1, 0.1, 0.1]
            axis2[i] = n
            axis2 = project(proj, Point3D(axis2...))
            Luxor.sethue(axes_colors[i])
            if (axis1 !== nothing) && (axis2 !== nothing) && !isapprox(axis1, axis2)
                Luxor.arrow(axis1, axis2)
                Luxor.label(axes_texts[i], :N, axis2, offset=10)
            end
        end
    end
end

# Interace to Yao
function state_to_polar(reg::AbstractRegister{2})
    @assert nqudits(reg) == 1 "Only single qubit register is allowed to plot on bloch sphere. If you want to plot a subsystem as a mixed state, please construct a density matrix first with `density_matrix`."
    @assert nbatch(reg) == 1 || nbatch(reg) == YaoBlocks.NoBatch() "Only single batch register is allowed to plot on bloch sphere."
    return state_to_polar(statevec(reg))
end

function state_to_cartesian(reg::DensityMatrix{2})
    @assert nqudits(reg) == 1 "Only single qubit density matrix is allowed to plot on bloch sphere"
    return real(tr(reg.state * mat(X))), real(tr(reg.state * mat(Y))), real(tr(reg.state * mat(Z)))
end
